Changes to bldpkg script:

Fixed identation in parts of the script
Moved SM_COMMENCEDATE variable at the top of the script
Merged SM_HTMLOUTPUT code above inarray function code into one below that function
Created two new functions - passfailcleanup and interruptcleanup. passfailcleanup deals and moved SM_HTMLOUTPUT code from existing prepbuildsummary and interruptsummary
into those two functions
This commit is contained in:
SMLinux 2022-02-06 19:41:10 +05:30
parent ed95528e8f
commit ec8d4408fb

272
bldpkg
View file

@ -7,6 +7,10 @@ set -e
# All variable names are to be in upper-case, function names in lower-xase.
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below. This output goes
# into package build summary.
SM_COMMENCEDATE="$(date '+%a, %d %b %Y, %T')"
# Store the source directory path the build was initiated from
SRCDIR="$PWD"
@ -17,11 +21,11 @@ SRCDIRRPATH="$(basename $SRCDIR)"
genchecksum() {
echo "Discarding old SHA512SUMS from $SRCDIRRPATH.SMBuild"
sed -E -i \
-e '/^SHA512SUMS=".*"$/d' \
-e '/^SHA512SUMS="/,/"$/d' \
-e "/^SHA512SUMS='.*'\$/d" \
-e "/^SHA512sums='/,/'\$/d" \
"$SRCDIRRPATH".SMBuild
-e '/^SHA512SUMS=".*"$/d' \
-e '/^SHA512SUMS="/,/"$/d' \
-e "/^SHA512SUMS='.*'\$/d" \
-e "/^SHA512sums='/,/'\$/d" \
"$SRCDIRRPATH".SMBuild
echo "Adding new SHA512SUMS in $SRCDIRRPATH.SMBuild..."
printf 'SHA512SUMS="\n' >> "$SRCDIRRPATH".SMBuild
@ -85,15 +89,6 @@ fi
#the source directory $SRCDIR
mkdir -p $SM_PARENTTMP
# If $SM_HTMLOUTPUT is set to 1, echo $APP, $VERSION and $BUILD as file names inside the parent build directory.
# This will output into an HTML file so that the basic status of the build process (whether started, stopped,
# interrupted or failed) can be viewed in the web browser.
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
echo $APP > $SM_PARENTTMP/$APP.APP
echo $VERSION > $SM_PARENTTMP/$APP.VERSION
echo $BUILD > $SM_PARENTTMP/$APP.BUILD
fi
# Function to specifically match arrays inside a value. This function will be used later on to perform package
# and directory matches using certain conditions. Note: "${ARRAY[@]}" =~ "${VARIABLE}" isn't fool-proof.
inarray() {
@ -106,11 +101,15 @@ inarray() {
return 1
}
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below. This output goes
# into package build summary.
SM_COMMENCEDATE="$(date '+%a, %d %b %Y, %T')"
# If $SM_HTMLOUTPUT is set to 1, echo $APP, $VERSION and $BUILD as file names inside the parent build directory.
# This will output into an HTML file so that the basic status of the build process (whether started, stopped,
# interrupted or failed) can be viewed in the web browser.
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
echo $APP > $SM_PARENTTMP/$APP.APP
echo $VERSION > $SM_PARENTTMP/$APP.VERSION
echo $BUILD > $SM_PARENTTMP/$APP.BUILD
if [ -n "$SM_AUTOBUILD" ] ; then
cat << EOF >> $SM_PARENTTMP/BUILDMONITOR
<b>$SM_COMMENCEDATE | Building package # $CURRENTPKGNUMBER / $TOTALPKGNUMBER: <i><a href="/smlinux/pkgresults?pkg=$APP&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$APP $VERSION</a></i></b>
@ -132,7 +131,7 @@ if ! inarray "${PKGEXT}" "${SM_VALIDPKGEXTENSIONS[@]}" ; then
exit 1
fi
# Figure out the compression tool to be used based on the $PKGEXT variable set in buildvars.conf. At the same time,
# Figure out the compression tool to be used based on the $PKGEXT variable set in bldpkg.conf. At the same time,
# export the compressor options set for makepkg to import from the build environment.
case "$PKGEXT" in
tgz) COMPRESSOR=gzip
@ -149,9 +148,9 @@ case "$PKGEXT" in
export COMPRESSOPTS ;;
esac
echo -n "Validating $COMPRESSOR...."
# Borrowed from slackware's installpkg utility
if ! $COMPRESSOR --help 1> /dev/null 2> /dev/null ; then
echo -n "Validating $COMPRESSOR...."
if ! $COMPRESSOR --help > /dev/null 2>&1 ; then
echo "[FAILED]"
exit 1
else
@ -173,7 +172,7 @@ if [ "$SM_SWAPCHECK" = "1" ]; then
if inarray "${APP}" "${SM_PACKAGESREQUIRINGSWAP[@]}" ; then
# Here we determine available system swap size needed to compile exceptional packages that pull in a lot of RAM.
# Those packages are listed under the SM_PACKAGESREQUIRINGSWAP array in /etc/buildvars.conf. Check whether swap
# Those packages are listed under the SM_PACKAGESREQUIRINGSWAP array in /etc/bldpkg.conf. Check whether swap
#is available on the system and if it is, determine its size. If its size is >= SM_SWAPSIZE, we are all good.
#If it's less than SM_SWAPSIZE, we exit with a status 1.
@ -192,8 +191,7 @@ fi
# If SM_USETMPFS is set to 1, SM_TMPFSDIR is defined and SM_TMPFSCHECKFAILED variable is unset, determine if the
# $APP is in the exception list and whether to build inside or outside the TMPFS directory.
if [ "$SM_USETMPFS" = "1" ] && [ -n "$SM_TMPFSDIR" ] && \
[ -z "$SM_TMPFSCHECKFAILED" ] ; then
if [ "$SM_USETMPFS" = "1" ] && [ -n "$SM_TMPFSDIR" ] && [ -z "$SM_TMPFSCHECKFAILED" ] ; then
# If $APP is in the TMPFS exception list inside /etc/bldpkg.conf, compile it *OUTSIDE* the TMPFS directory, i.e
# the non-TMPFS directory, else compile it *INSIDE* the TMPFS directory. This if/else is solely for deciding
@ -246,7 +244,7 @@ if [ "$SM_GLOBALDISTCC" = "1" ] ; then
if [ ! -x "$SM_DISTCCBINPATH" ]; then
echo "[ERROR] Oops! Distcc binary was not found but building with it"
echo "[ERROR] was requested! Either ensure distcc is in your "'$PATH'" or"
echo "[ERROR] disable this option in buildvars file. buildvars file"
echo "[ERROR] disable this option in bldpkg.conf file. bldpkg.conf file"
echo "[ERROR] is located in $BUILDVARS ! Aborting!"
exit 1
fi
@ -258,7 +256,7 @@ if [ "$SM_GLOBALDISTCC" = "1" ] ; then
elif [ ! -d "$SM_DISTCCSYMPATH" ] ; then
echo "[ERROR] $SM_DISTCCSYMPATH directory containing symlinks to distcc"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in buildvars.conf! Aborting!"
echo "[ERROR] based on instructions in bldpkg.conf! Aborting!"
exit 1
fi
@ -323,7 +321,7 @@ if [ "$SM_GLOBALCCACHE" = "1" ]; then
if [ ! -x "$SM_CCACHEBINPATH" ] ; then
echo "[ERROR] Oops! ccache binary was not found but building with it"
echo "[ERROR] was requested! Either ensure ccache is in your "'$PATH'" or"
echo "[ERROR] disable this option in buildvars.conf. buildvars.conf"
echo "[ERROR] disable this option in bldpkg.conf. buildvars.conf"
echo "[ERROR] file is located in $BUILDVARS . Aborting!"
exit 1
fi
@ -568,7 +566,6 @@ if [ -z "$SM_SKIPCHECKSUM" ] ; then
unset IFS
echo "Looks good..."
fi
#build
# Function to prevent a package from compiling on an unsupported architecture
compileonlyfor() {
@ -785,7 +782,8 @@ mkfinalpkg() {
find "$PKG" -print0 | xargs -0 file -m /etc/file/magic/archive | \
grep -E "current ar archive" | awk '{print $1}' | cut -d: -f1 | \
xargs strip --strip-unneeded 2>/dev/null || true
# Calculate total files, directories, symlinks and uncompressed staging directory size
if [ "$SM_SHOWSUMMARY" == "1" ] ; then
SM_TOTALFILECOUNT="$(find $PKG -type f | wc -l)"
SM_TOTALDIRCOUNT="$(find $PKG -type d | wc -l)"
@ -811,14 +809,6 @@ mkfinalpkg() {
echo "[INFO] Re-entering source directory $SRCDIR"
cd "$SRCDIR"
# Discard $APP.APP, $APP.BUILD and $APP.VERSION files if SM_AUTOBUILDTEMP is not set. If SM_AUTOBUILDTEMP is set,
# there's no need to discard these files because it's auto-discarded by the section build file itself.
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
if [ -z "$SM_AUTOBUILDTEMP" ] ; then
rm -f $SM_PARENTTMP/$APP.{APP,BUILD,VERSION}
fi
fi
if [ "$SM_SHOWSUMMARY" == "1" ]; then
# With SECONDS reset, the shell will add in a fresh value, which we can now use to ascertain the packaging time,
# by again passing that value as an argument to the runtime function
@ -831,8 +821,7 @@ mkfinalpkg() {
SM_BUILDDIRSIZE="$(du -s $SM_TMP | awk '{print $1}')"
# Calculate SSD write savings if TMPFS has been used
if [ "$SM_USETMPFS" = "1" ] && \
[ "$SM_TMPFSENABLEDFORTHISPACKAGE" = "1" ] ; then
if [ "$SM_USETMPFS" = "1" ] && [ "$SM_TMPFSENABLEDFORTHISPACKAGE" = "1" ] ; then
# Determine size of staging directory
SM_PKGDIRSIZE="$(du -s $PKG | awk '{print $1}')"
@ -854,8 +843,7 @@ mkfinalpkg() {
rm -rf "$SM_TMP"
else
systemdirectorydeletionmessage
echo "'"$SM_TMP"' IS LISTED AS A PROTECTED DIRECTORY BUT \
ACCIDENTALLY LISTED AS A VALUE FOR "'$SM_TMP'" VARIABLE!! EXITING!!"
echo "'"$SM_TMP"' IS LISTED AS A PROTECTED DIRECTORY BUT ACCIDENTALLY LISTED AS A VALUE FOR "'$SM_TMP'" VARIABLE!! EXITING!!"
exit 1
fi
fi
@ -866,14 +854,14 @@ ACCIDENTALLY LISTED AS A VALUE FOR "'$SM_TMP'" VARIABLE!! EXITING!!"
rm -rf "$PKG"
else
systemdirectorydeletionmessage
echo "'"$PKG"' IS LISTED AS A PROTECTED DIRECTORY BUT ACCIDENTALLY\
LISTED AS A VALUE FOR "'$PKG'" VARIABLE!! EXITING!!"
echo "'"$PKG"' IS LISTED AS A PROTECTED DIRECTORY BUT ACCIDENTALLY LISTED AS A VALUE FOR "'$PKG'" VARIABLE!! EXITING!!"
exit 1
fi
fi
}
prepbuildsummary() {
# Start of the SM_SHOWSUMMARY if/else check
if [ "$SM_SHOWSUMMARY" = "1" ]; then
# Get the build completion time and store it in a variable
@ -910,13 +898,11 @@ prepbuildsummary() {
# Determine if distcc was used. If SM_GLOBALDISTCC is enabled and set to 1 and SM_DISTCC is not declared in the
# package build file, then set SM_DSTATS in the build summary
if [ "$SM_GLOBALDISTCC" = "1" ] && \
[ -z "$SM_DISTCC" ]; then
if [ "$SM_GLOBALDISTCC" = "1" ] && [ -z "$SM_DISTCC" ]; then
SM_DSTATS="Yes"
# Else if SM_GLOBALDISTCC is enabled and set to 1 and SM_DISTCC is set to 0 in the package build file, then set
# SM_DSTATS in the build summary
elif [ "$SM_GLOBALDISTCC" = "1" ] && \
[ "$SM_DISTCC" = "0" ]; then
elif [ "$SM_GLOBALDISTCC" = "1" ] && [ "$SM_DISTCC" = "0" ]; then
SM_DSTATS="Nope, disabled but global variable set"
# Else If SM_GLOBALDISTCC is unset, set SM_DSTATS in the build summary
elif [ -z "$SM_GLOBALDISTCC" ] || [ "$SM_GLOBALDISTCC" = "0" ]; then
@ -955,16 +941,13 @@ prepbuildsummary() {
# Determine whether tmpfs was used
if [ "$SM_USETMPFS" = "1" ] && \
[ "$SM_TMPFSENABLEDFORTHISPACKAGE" = "1" ] ; then
if [ "$SM_USETMPFS" = "1" ] && [ "$SM_TMPFSENABLEDFORTHISPACKAGE" = "1" ] ; then
SM_TMPFSSTATE="Yes"
elif [ "$SM_USETMPFS" = "1" ] && \
[ "$SM_TMPFSENABLEDFORTHISPACKAGE" = "0" ]; then
elif [ "$SM_USETMPFS" = "1" ] && [ "$SM_TMPFSENABLEDFORTHISPACKAGE" = "0" ]; then
SM_TMPFSSTATE="*Not for this package* but enabled globally"
elif [ "$SM_USETMPFS" = "1" ] && \
[ "$SM_TMPFSCHECKFAILED" = "1" ]; then
elif [ "$SM_USETMPFS" = "1" ] && [ "$SM_TMPFSCHECKFAILED" = "1" ]; then
SM_TMPFSSTATE="*NOPE, TMPFS DIRECTORY CHECK FAILED* but enabled globally"
else
@ -990,172 +973,105 @@ prepbuildsummary() {
# Determine if the build was successful or not
if [ "$SM_PKGSTATUS" = "0" ] ; then
SM_BLDSTATUS="$(echo -e "$SM_COLOURG"'Successful! :-D' \
"$SM_COLOURD")"
SM_BLDSTATUS="$(echo -e "$SM_COLOURG"'Successful! :-D' "$SM_COLOURD")"
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
cat << EOF >> $SM_PARENTTMP/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$APP&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$APP $VERSION</a></i></b></td><td>$SM_COMMENCEDATE</td><td>$SM_FINISHDATE</td><td>$SM_TOTALTIME</td><td><b style="color:#00cc00;">SUCCEEDED</b></td></tr>
EOF
rm -f $SM_PARENTTMP/BUILDING
fi
# Determine the compressed size
SM_PACKSIZE="$(du -bk "$SM_PACKLOCATION" | awk '{print $1}')"
# Determine the compressed size
SM_PACKSIZE="$(du -bk "$SM_PACKLOCATION" | awk '{print $1}')"
# Determine the uncompressed size
SM_PACKUSIZE="$(echo $SM_PACKUSIZE1)"
elif [ "$SM_WASINTERRUPTED" = "1" ]; then
SM_BLDSTATUS="$(echo -e "$SM_COLOURY"\
'** INTERRUPTED ** :-/'"$SM_COLOURD")"
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
cat << EOF >> $SM_PARENTTMP/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$APP&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$APP $VERSION</a></i></b></td><td>$SM_COMMENCEDATE</td><td>$SM_FINISHDATE</td><td>$SM_TOTALTIME</td><td><b>INTERRUPTED</b></td></tr>
EOF
rm -f $SM_PARENTTMP/BUILDING
fi
SM_BLDSTATUS="$(echo -e "$SM_COLOURY"'** INTERRUPTED ** :-/'"$SM_COLOURD")"
else
SM_BLDSTATUS="$(echo -e "$SM_COLOURR"'!! FAILED !! :-('\
"$SM_COLOURD")"
if [ -n "$SM_HTMLOUTPUT" ] && [ "$SM_HTMLOUTPUT" = "1" ] ; then
cat << EOF >> $SM_PARENTTMP/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$APP&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$APP $VERSION</a></i></b></td><td>$SM_COMMENCEDATE</td><td>$SM_FINISHDATE</td><td>$SM_TOTALTIME></td><td><b style="color:#ff1a1a;">FAILED</b></td></tr>
EOF
rm -f $SM_PARENTTMP/BUILDING
fi
SM_BLDSTATUS="$(echo -e "$SM_COLOURR"'!! FAILED !! :-('"$SM_COLOURD")"
fi
# Finally prepare the summary
echo "" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC"---------------------------------------------\
----------------------------------" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC"-------------------------------------------------------------------------------" >> "$SM_TEMPFILE"
echo -e " BUILD SUMMARY FOR PACKAGE "$SM_COLOURD"'"$SM_COLOURV"\
"$APP""$SM_COLOURD"'"$SM_COLOURC" VERSION "$SM_COLOURD"'"$SM_COLOURV"\
"$VERSION"'" "$SM_COLOURC"TAG"$SM_COLOURV" "'$BUILD'"$SM_COLOURD"" \
>> "$SM_TEMPFILE"
"$APP""$SM_COLOURD"'"$SM_COLOURC" VERSION "$SM_COLOURD"'"$SM_COLOURV""$VERSION"'" "$SM_COLOURC"TAG"$SM_COLOURV" "'$BUILD'"$SM_COLOURD"" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC"---------------------------------------------\
----------------------------------"$SM_COLOURD"" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC"-------------------------------------------------------------------------------"$SM_COLOURD"" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Build Status:"$SM_COLOURD" \
$SM_BLDSTATUS" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Build Status:"$SM_COLOURD" $SM_BLDSTATUS" >> "$SM_TEMPFILE"
# Output the section name if SM_AUTOBUILDTEMP is set. This means we are running an autobuild.
if [ -n "$SM_AUTOBUILDTEMP" ]; then
echo -e ""$SM_COLOURC" Build Section:"$SM_COLOURD" $SECTION" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Build Section:"$SM_COLOURD" $SECTION" >> "$SM_TEMPFILE"
fi
# If we have $SM_COMPILETIMEB set, then assume the compile went well and output compile and packaging times
# into SM_TEMPFILE.
if [ -n "$SM_TOTALTIME" ] && [ -z "$SM_PACKAGETIMEB" ]; then
echo -e ""$SM_COLOURC" Total Time: "$SM_COLOURD" $SM_TOTALTIME" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Total Time: "$SM_COLOURD" $SM_TOTALTIME" >> "$SM_TEMPFILE"
elif [ -n "$SM_TOTALTIME" ] && [ -n "$SM_PACKAGETIMEB" ]; then
echo -e ""$SM_COLOURC" Total Time: "$SM_COLOURD" $SM_TOTALTIME \
( $SM_COMPILETIMEB Compile ) + ( $SM_PACKAGETIMEB Packaging )" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Total Time: "$SM_COLOURD" $SM_TOTALTIME ( $SM_COMPILETIMEB Compile ) + ( $SM_PACKAGETIMEB Packaging )" >> "$SM_TEMPFILE"
fi
echo -e ""$SM_COLOURC" Started:"$SM_COLOURD" $SM_COMMENCEDATE" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Stopped:"$SM_COLOURD" $SM_FINISHDATE" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Started:"$SM_COLOURD" $SM_COMMENCEDATE" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Stopped:"$SM_COLOURD" $SM_FINISHDATE" >> "$SM_TEMPFILE"
# If the package was built successfully, output the installer sizes
if [ "$SM_PKGSTATUS" = "0" ]; then
#SM_COMPRESSEDSIZE="$(echo $(($SM_PACKSIZE * 100 / $SM_PACKUSIZE)))"
# Space saving = 1 - Compressed Size / Uncompressed size.
# Also, bc code taken from:
# https://stackoverflow.com/questions/56945130/bash-echo-percentage-with-no-decimal-point-with-result-returned-from-bc-comman
SM_COMPRESSEDSIZE="$(echo $(echo "scale=2 ; 1 - "$SM_PACKSIZE" / \
"$SM_PACKUSIZE"" | bc ) | sed 's@.@@')"
SM_COMPRESSEDSIZE="$(echo $(echo "scale=2 ; 1 - "$SM_PACKSIZE" / "$SM_PACKUSIZE"" | bc ) | sed 's@.@@')"
echo -e ""$SM_COLOURC" Source Size: "$SM_COLOURD" Compressed: \
$SM_SRCDIRSIZE"K", Uncompressed: $SM_BUILDDIRSIZE"K"" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Source Size: "$SM_COLOURD" Compressed: $SM_SRCDIRSIZE"K", Uncompressed: $SM_BUILDDIRSIZE"K"" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Package Size: "$SM_COLOURD" Uncompressed: \
$SM_PACKUSIZE"K", Compressed: $SM_PACKSIZE"K" ("$SM_COMPRESSEDSIZE'%'")" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Package Size: "$SM_COLOURD" Uncompressed: $SM_PACKUSIZE"K", Compressed: $SM_PACKSIZE"K" ("$SM_COMPRESSEDSIZE'%'")" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Package Has: "$SM_COLOURD" \
$SM_TOTALFILECOUNT files and $SM_TOTALSYMCOUNT symlinks in $SM_TOTALDIRCOUNT \
directories" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Package Has: "$SM_COLOURD" $SM_TOTALFILECOUNT files and $SM_TOTALSYMCOUNT symlinks in $SM_TOTALDIRCOUNT directories" >> "$SM_TEMPFILE"
fi
# If ccache was used, output the current cache used size and max allocated size
if [ "$SM_GLOBALCCACHE" = "1" ] && [ "$SM_CCACHE" != "0" ] && \
[ "$SM_CSTATS" = "Yes" ]; then
if [ "$SM_GLOBALCCACHE" = "1" ] && [ "$SM_CCACHE" != "0" ] && [ "$SM_CSTATS" = "Yes" ]; then
SM_CCACHEUSEDSIZE="$(ccache -s | grep "cache size" | head -n 1 | \
awk '{ $1=$2="" ; print $0}')"
SM_CCACHETOTALSIZE="$(ccache -s | grep "max cache size" | \
awk '{ $1=$2=$3="" ; print $0}')"
echo -e ""$SM_COLOURC" Ccache Used?"$SM_COLOURD" "$SM_CSTATS",\
"$SM_CCACHEUSEDSIZE" /"$SM_CCACHETOTALSIZE" Allocated" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Ccache Used?"$SM_COLOURD" "$SM_CSTATS","$SM_CCACHEUSEDSIZE" /"$SM_CCACHETOTALSIZE" Allocated" >> "$SM_TEMPFILE"
else
echo -e ""$SM_COLOURC" Ccache Used?"$SM_COLOURD" "$SM_CSTATS"" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Ccache Used?"$SM_COLOURD" "$SM_CSTATS"" >> "$SM_TEMPFILE"
fi
echo -e ""$SM_COLOURC" Distcc Used?"$SM_COLOURD" $SM_DSTATS" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Distcc Used?"$SM_COLOURD" $SM_DSTATS" >> "$SM_TEMPFILE"
# If distcc was used, cut out --randomize and output rest of the DISTCC_HOSTS variable
if [ "$SM_GLOBALDISTCC" = "1" ] && [ "$SM_DISTCC" != "0" ]; then
echo -e ""$SM_COLOURC" Distcc Args: "$SM_COLOURD" $(echo \
"$DISTCC_HOSTS" | sed 's@--randomize@@')" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Distcc Args: "$SM_COLOURD" $(echo "$DISTCC_HOSTS" | sed 's@--randomize@@')" >> "$SM_TEMPFILE"
fi
echo -e ""$SM_COLOURC" TMPFS Used? "$SM_COLOURD" "$SM_TMPFSSTATE" $SM_TMPFSSAVINGSSIZE" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" TMPFS Used? "$SM_COLOURD" "$SM_TMPFSSTATE" $SM_TMPFSSAVINGSSIZE" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" CPU Threads: "$SM_COLOURD" $(echo $SM_MAKEFLAGS | \
sed 's@-j@@')" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" CPU Threads: "$SM_COLOURD" $(echo $SM_MAKEFLAGS | sed 's@-j@@')" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" CFLAGS Used: "$SM_COLOURD" $CFLAGS" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" CFLAGS Used: "$SM_COLOURD" $CFLAGS" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Compressor: "$SM_COLOURD" $COMPRESSOR \
($COMPRESSOPTS)" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Compressor: "$SM_COLOURD" $COMPRESSOR ($COMPRESSOPTS)" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Build Type:" $SM_COLOURD" $SM_BUILDSYS \
& $SM_BLDTYPE" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC" Build Type:" $SM_COLOURD" $SM_BUILDSYS & $SM_BLDTYPE" >> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC"---------------------------------------------------\
----------------------------"$SM_COLOURD"" \
>> "$SM_TEMPFILE"
echo -e ""$SM_COLOURC"-------------------------------------------------------------------------------"$SM_COLOURD"" >> "$SM_TEMPFILE"
# Output the build summary to the user on every build
@ -1171,6 +1087,7 @@ directories" \
# Invoke promptuser function
promptuser
}
promptuser() {
@ -1181,7 +1098,7 @@ promptuser() {
while true ; do
echo
echo "[NOTIFY] '"$APP"' has been built and SM_EXTRACTPROMPT is enabled in"
echo "[NOTIFY] buildvars.conf file. Would you like to extract and examine contents"
echo "[NOTIFY] bldpkg.conf file. Would you like to extract and examine contents"
echo "[NOTIFY] of its package installer in a 'test' directory within the"
echo "[NOTIFY] current source directory"
echo "[NOTIFY] ($SRCDIR) ?"
@ -1206,7 +1123,7 @@ promptuser() {
while true ; do
echo
echo "[NOTIFY] '"$APP"' successfully built and SM_INSTALLPROMPT is enabled in the buildvars.conf file."
echo "[NOTIFY] '"$APP"' successfully built and SM_INSTALLPROMPT is enabled in the bldpkg.conf file."
read -r -p "[NOTIFY] Would you like to install/upgrade it? (y/N) " yn
case $yn in
@ -1222,7 +1139,54 @@ promptuser() {
exit 0
fi
}
passfailcleanup() {
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
cat << EOF >> $SM_PARENTTMP/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$APP&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$APP $VERSION</a></i></b></td><td>$SM_COMMENCEDATE</td><td>$SM_FINISHDATE</td><td>$SM_TOTALTIME</td><td><b style="color:#00cc00;">SUCCEEDED</b></td></tr>
EOF
fi
rm -f $SM_PARENTTMP/BUILDING
# Discard $APP.APP, $APP.BUILD and $APP.VERSION files if SM_AUTOBUILDTEMP is not set. If SM_AUTOBUILDTEMP is set,
# there's no need to discard these files because it's auto-discarded by the section build file itself.
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
if [ -z "$SM_AUTOBUILDTEMP" ] ; then
rm -f $SM_PARENTTMP/$APP.{APP,BUILD,VERSION}
fi
fi
prepbuildsummary
}
interruptcleanup() {
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
cat << EOF >> $SM_PARENTTMP/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$APP&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$APP $VERSION</a></i></b></td><td>$SM_COMMENCEDATE</td><td>$SM_FINISHDATE</td><td>$SM_TOTALTIME</td><td><b>INTERRUPTED</b></td></tr>
EOF
fi
rm -f $SM_PARENTTMP/BUILDING
# Discard $APP.APP, $APP.BUILD and $APP.VERSION files if SM_AUTOBUILDTEMP is not set. If SM_AUTOBUILDTEMP is set,
# there's no need to discard these files because it's auto-discarded by the section build file itself.
if [ "$SM_HTMLOUTPUT" = "1" ] ; then
if [ -z "$SM_AUTOBUILDTEMP" ] ; then
rm -f $SM_PARENTTMP/$APP.{APP,BUILD,VERSION}
fi
fi
interruptsummary
}
# https://unix.stackexchange.com/questions/462392/bash-the-function-is-executed-twice
# https://stackoverflow.com/questions/9256644/identifying-received-signal-name-in-bash/9256709
# We use two traps to identify the signals, EXIT and INT. EXIT will invoke 'prepbuildsummary' function on any exit
@ -1230,7 +1194,7 @@ promptuser() {
# The 'interrruptsummary' function is invoked when the user sends CTRL-C aka SIGINT. The SIGINT trap does not work
# for auto builds, it has been added in the section build file too.
trap "prepbuildsummary" EXIT
trap "interruptsummary" INT
trap "passfailcleanup" EXIT
trap "interruptcleanup" INT
build